;;picview.asm
;;assemble with nasmw (ver 0.98.39)

%include "nagoa+.inc"
;%macro API 2                                   ;Function , Library  (i have this macro definition in nagoa+.inc)
;	import %1 %2
;	extern %1
;%endmacro

;; got this structure definition with the help of h2inc.exe 

struc GdiplusStartupInput      
  .GdiplusVersion  resd 1		; UINT32 (??? size unknown)	 +000h
  .DebugEventCallback resd 1		; DebugEventProc (??? size unknown)	 +004h
  .SuppressBackgroundThread resd 1	; BOOL (??? size unknown)	 +008h
  .SuppressExternalCodecs resd 1	; BOOL (??? size unknown)	 +00Ch
endstruc	; 32 bytes

API GetModuleHandleA, kernel32.dll
API RegisterClassExA, user32.dll
API LoadIconA,user32.dll
API CreateWindowExA, user32.dll
API MessageBoxA, user32.dll
API SendMessageA, user32.dll
API DefWindowProcA, user32.dll
API ExitProcess, kernel32.dll
API GetMessageA, user32.dll
API DispatchMessageA, user32.dll
API TranslateMessage,user32.dll
API PostMessageA,user32.dll
API ShowWindow,user32.dll
API UpdateWindow,user32.dll
API GetCommandLineA,kernel32.dll
API PostQuitMessage,user32.dll
API LoadCursorA,user32.dll

API GlobalAlloc,kernel32.dll
API GlobalFree,kernel32.dll

API GetWindowDC,user32.dll
API ReleaseDC,user32.dll
API GlobalLock,kernel32.dll
API RtlMoveMemory,kernel32.dll
API GlobalUnlock,kernel32.dll
API CreateStreamOnHGlobal,ole32.dll

API GdipCreateBitmapFromStream,gdiplus.dll
API GdiplusStartup,gdiplus.dll
API GdiplusShutdown,gdiplus.dll
API GdipCreateFromHDC,gdiplus.dll
API SetWindowPos,user32.dll

API GdipGetImageDimension,gdiplus.dll
API GdipDrawImageRect,gdiplus.dll
API GdipGetImageWidth,gdiplus.dll
API GdipGetImageHeight,gdiplus.dll

WM_SUBQ equ WM_USER+101
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
segment .data USE32

JPG_ID equ 2000
BITMAP_ID equ 2001

Windowname db 'picview',0
CommandLine	dd 0
Windowhandle            	dd 0
Instance        	dd 0
Windowclassname db "OurWindowclass",0
OurWindowclass:	
istruc WNDCLASSEX
	at WNDCLASSEX.cbSize,		dd WNDCLASSEX_size
	at WNDCLASSEX.style,		dd CS_HREDRAW|CS_VREDRAW
	at WNDCLASSEX.lpfnWndProc,	dd WindowProc
	at WNDCLASSEX.hbrBackground,	dd COLOR_BTNFACE+1
	at WNDCLASSEX.lpszMenuName,	dd 0
	at WNDCLASSEX.lpszClassName,	dd Windowclassname
iend
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
segment .bss USE32

MessageBuffer resb MSG_size
hGmem resd 1
hDC resd 1
itm1 resb 32
hmainbit resd 1
Bitmap resd 1
GraphObj resd 1
picWidth resd 1
picHeight resd 1
hGDIPlus resd 1
actWidth resd 1
actHeight resd 1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
segment .code USE32
..start:

call GetModuleHandleA, 0
mov dword [Instance], eax

call GetCommandLineA
mov dword [CommandLine], eax
loccall WinMain, [Instance], NULL, eax
getout:
call ExitProcess, eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc WinMain, hInstance, hPrevInstance, lpCmdLine
       mov eax, dword [Instance]
       mov dword [OurWindowclass+WNDCLASSEX.hInstance], eax
       call LoadIconA, NULL, IDI_APPLICATION
       mov dword [OurWindowclass+WNDCLASSEX.hIcon], eax
       mov dword [OurWindowclass+WNDCLASSEX.hIconSm], eax
       call LoadCursorA, NULL, IDC_ARROW
       mov dword [OurWindowclass+WNDCLASSEX.hCursor], eax
          
       call RegisterClassExA,OurWindowclass
       test eax, eax
       jnz .DoAndShow
       return

.DoAndShow:
      ;--- create and show the main program window
	call CreateWindowExA,NULL,Windowclassname,Windowname,WS_OVERLAPPED|WS_CAPTION|WS_SIZEBOX|WS_MAXIMIZEBOX|WS_MINIMIZEBOX |WS_SYSMENU,100,100,800,500, NULL, NULL, [Instance], NULL
	mov dword [Windowhandle], eax
	call ShowWindow, [Windowhandle],SW_MAXIMIZE
	call UpdateWindow,[Windowhandle]

; -- every time user moves mouse or imput some msg this loop is activated
; -- in order to get all messages imputed by the user 
.loop
	call GetMessageA,MessageBuffer, NULL, 0, 0         
	cmp eax, 0
	jb .erro
	je .fin
	call TranslateMessage,MessageBuffer
	call DispatchMessageA,MessageBuffer
	jmp .loop
	.erro:
	call MessageBoxA, 0, "ERROR", "Sorry ...", MB_OK
	.fin:
	mov eax, dword[MessageBuffer+MSG.wParam]
endproc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc WindowProc,hwnd,uMsg,wParam,lParam
	pusha
	if dword[@uMsg],e,WM_CLOSE
		loccall end_gdiplus
		call ReleaseDC,[hmainbit],[hDC]
		call ExitProcess,0
		
		jmp near returntrue
	endif
	if dword[@uMsg],e,WM_DESTROY
		loccall end_gdiplus               
		call ReleaseDC,[hmainbit],[hDC]
		call PostQuitMessage, 0	
		xor eax,eax
		jmp near returntrue
	endif
	if dword[@uMsg],e,WM_CREATE
		%assign .style  WS_CHILD | WS_VISIBLE |SS_BITMAP
		call CreateWindowExA, WS_EX_CLIENTEDGE, "STATIC","",.style ,50,50,1300,1300,[@hwnd],BITMAP_ID, [Instance], NULL 
		mov [hmainbit],eax
		loccall start_gdiplus    ;; init gdiplus.
		
		call GetWindowDC,[hmainbit]
		mov [hDC],eax
		
		call PostMessageA,[@hwnd],WM_SUBQ,0,0     ;; WM_SUBQ is user defined message.
		jmp near returntrue
	endif
	if dword[@uMsg],e,WM_PAINT
		loccall DrawScene
	endif
	if dword[@uMsg],e,WM_SUBQ
		loccall LoadImageFromResource,JPG_ID,[Instance]   ;; loads the picture from the resource and displays it.
		
		call GdipGetImageWidth,[Bitmap],actWidth
		call GdipGetImageHeight,[Bitmap],actHeight
		call SetWindowPos,[hmainbit],NULL,NULL,NULL,[actWidth],[actHeight],SWP_NOZORDER|SWP_NOMOVE  ;; to make the image fit in our static control
		jmp near returntrue
	endif
	
	if dword [@uMsg],e,WM_COMMAND
		jmp near returntrue
	endif
	popa
defaultaction:
	call DefWindowProcA, [@hwnd], [@uMsg], [@wParam], [@lParam]
	return
returnfalse:
	popa
	return FALSE
returntrue:
	popa
	return TRUE
endproc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc start_gdiplus
	stack GpStartInput,GdiplusStartupInput_size
		
	mov dword[@GpStartInput+GdiplusStartupInput.GdiplusVersion],1
	mov dword[@GpStartInput+GdiplusStartupInput.DebugEventCallback],NULL
	mov dword[@GpStartInput+GdiplusStartupInput.SuppressBackgroundThread],NULL
	mov dword[@GpStartInput+GdiplusStartupInput.SuppressExternalCodecs],NULL
	call GdiplusStartup,hGDIPlus,ADDR @GpStartInput,NULL
endproc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc LoadImageFromResource,resid,Inst
	stack m_hBuffer,4,pBuffer,4,pStream,4,m_pBitmap,4,m_pBitmap_status,4
	stack GraphicObject,4
	stack hResource,4
	
	call GlobalAlloc,GMEM_MOVEABLE,image1_size
	mov [@m_hBuffer],eax
	call GlobalLock,[@m_hBuffer]
	mov [@pBuffer],eax
	call RtlMoveMemory,[@pBuffer],image1,image1_size
	
	call CreateStreamOnHGlobal,[@m_hBuffer],FALSE,ADDR @pStream
	
	call GdipCreateBitmapFromStream,[@pStream],ADDR @m_pBitmap
	mov eax,[@m_pBitmap]
	mov [Bitmap],eax
	
	call GdipCreateFromHDC,[hDC],ADDR @GraphicObject
	mov eax,[@GraphicObject]
	mov [GraphObj],eax
	
	call GdipGetImageDimension,[@m_pBitmap],picWidth,picHeight
	call GdipDrawImageRect,[GraphObj],[Bitmap], 0, 0,[picWidth],[picHeight]

	call GlobalUnlock,[@m_hBuffer]
	call GlobalFree,[@m_hBuffer]
	
endproc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc DrawScene
	call GdipDrawImageRect,[GraphObj],[Bitmap], 0, 0,[picWidth],[picHeight]
endproc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc end_gdiplus
	call GdiplusShutdown,[hGDIPlus]
endproc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
image1:                          ;;not but not the least ..our picture..
incbin "sachin.jpg"
image1_size equ $-image1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;